/* globals PIXI, kd, requestAnimFrame */
	"use strict";
	
	// create an new instance of a pixi stage
	var stage = new PIXI.Stage(0xFFFFFF);
	
	// create a renderer instance
	var renderer = PIXI.autoDetectRenderer(800, 600);
	
	// create a loader with all the imag assets
	var loader = new PIXI.AssetLoader([
	                                   'assets/img/ship.png',
	                                   'assets/img/ship_exhaust_orange.png',
	                                   'assets/img/ship_exhaust_yellow.png',
	                                   'assets/img/skyscraper.png',
	                                   'assets/img/wormhole.png'
	                                   ]);
	
	function stageSplash() {
		// TODO: add splash screen
		
		
		config.game.maptype = MAPTYPE_SPACE; 
		
//		config.game.maptype = MAPTYPE_PLANET;
//		config.game.action = ACTION_INIT;
		
	}
	
	
	// prepare to start when loaded
	loader.onComplete = start;
	// show loading screen after first image, which is the logo
	loader.onProgress = stageSplash(); // does this really get called? Meh, whatever...
	loader.load();
	
	function showTime() {
		
		if (config.game.timer<0) {
			config.game.timer=0;
		}

		if (config.game.timer == 0) {
			config.game.loosing = true;
		}
		
		var seconds0 = Math.floor(parseInt(config.game.timer)/10000,0);
		var seconds1 = Math.floor(parseInt(config.game.timer%10000)/1000,0);
		var milisec0 = Math.floor(parseInt(config.game.timer%1000)/100,0);
		var milisec1 = Math.floor(parseInt(config.game.timer%100)/10,0);
		var milisec2 = Math.floor(parseInt(config.game.timer%10),0);
		
		document.getElementById("smerf-timer").innerHTML =
			"00:" + seconds0 + seconds1 +
			":" + milisec0 + milisec1 + milisec2;
	}
	
	// call start when everything has loaded
	function start() {
		
		var timestart = Date.now();
		var timeend = Date.now();
		var timeused = 0;
		
		// add the stats counter
		if (dev) {
			var stats = new Stats();
			stats.setMode( 1 );
			document.body.appendChild( stats.domElement );
			
			//document.body.appendChild('<div id="debug"></div>');
		}
		
		
		// create the ship
		stageShip();
		
		stageSpace();
		
		stagePlanet();
		
		//space.hide();
		
		// add the renderer view element to the DOM
//		renderer.view.style.position = "absolute"
//		renderer.view.style.marginLeft = "-400px";
//		renderer.view.style.marginTop = "-300px";
//		renderer.view.style.top = "50%";
//		renderer.view.style.left = "50%";
//		renderer.view.style.display = "block";
		document.body.appendChild(renderer.view);
		
		// init timer
		var mytimer = document.createElement( 'div' );
		mytimer.id = "smerf-timer";
		mytimer.style.cssText = 'width:120px;opacity:0.9;position:absolute;';
		document.body.appendChild(mytimer);
		
		//document.getElementById("smerf-timer").innerHTML = config.game.timer;
		
		requestAnimFrame( animate );
		
		// create a texture from an image path
		stage.addChild(ship.sprite);
		
		config.game.starttime = Date.now();
		
		config.game.timer = 10000;
		
		function animate() {
		
			timeused = Date.now() - timestart;
			timestart = Date.now();
			// console.log("s: " + timestart + ", e: " + timeend + ", u:  " + timeused);	
			if (dev)
				stats.begin();
			// poke the kbd function a little
		    kd.tick();

		    if (dev)
		    	if (config.frameno%30==0) {
		    		console.log("Started: " + config.space.ship.started + ", MType: " + config.game.maptype + ", Action: " + config.game.action);
		    		console.log("Loosing: " + config.game.loosing + ", Winning: " + config.game.winning);
		    	}
		    
		    if (!config.game.loosing && !config.game.winning) {
		    
			    if (config.game.maptype == MAPTYPE_SPACE) {
	
			    	if (config.game.action == ACTION_LIFTOFF) {
			    		config.game.action = ACTION_PLAY;
			    		
	//		    		space.activate();
			    		
			    		config.space.ship.started = false;
			    		
			    		if (dev)
			    			console.log("Planet: " + config.planetContact);
			    		
			    		ship.sprite.position.x = 
			    				config.space.planets.list[config.planetContact].obj.position.x + 
			    				config.space.planets.list[config.planetContact].radius + (ship.sprite.height/2*ship.sprite.scale.x);
			    		ship.sprite.position.y = config.space.planets.list[config.planetContact].obj.position.y;
			    		
			    		ship.sprite.scale = new PIXI.Point(config.space.ship.zoom, config.space.ship.zoom);
			    		
			    		if (dev) console.log("Sx: " + ship.sprite.position.x + ", Sy: " + ship.sprite.position.y);
			    		
	//		    		ship.sprite.rotation = config.space.planet.shiprotation;
	//		    		config.space.ship.rotation_curr = ship.sprite.rotation;
	//		    		
	//		    		ship.sprite.scale = ship.zoom;
			    		
			    	}
			    	
			    	if (!config.space.pause) {
			    	
				    	space.render();
				    	
				    	// update counter
				    	config.game.timer -= timeused;
				    	
				    	showTime();
				    	
			    	} else {
			    		//console.log(config.planetContact);
			    		
			    		// we are paused, check if we have a game action
			    		
			    		// ok, changing scen, fade out
					    if (config.planetContact!=0 && !config.space.hidden) {
					    	if (dev)
					    		console.log("fade");
					    	config.space.alpha -= 0.04;
	
					    	if (config.space.alpha<0) {
	
					    		config.space.alpha = 0;
					    		space.hide();
					    		ship.hide();
					    		config.space.hidden = true;
					    		
					    		// switch to planet
					    		config.game.maptype = MAPTYPE_PLANET;
					    		config.game.action  = ACTION_INIT;
					    	} else {
					    		space.setAlpha(config.space.alpha);
					    		ship.setAlpha(config.space.alpha);
					    	}
					    }
			    	}
			    	
			    } else if (config.game.maptype == MAPTYPE_PLANET) {
			    	
			    	if (config.game.action == ACTION_INIT) {
			    		planet.init();
			    		config.game.action = ACTION_INTRO;
			    		ship.setAlpha(1);
			    		ship.show();
			    		config.planet.ship.started = false;
			    	}
			    	
			    	if (config.game.action == ACTION_PLAY) {
			    		
				    	if (config.planet.ship.started) {
					    	// update counter
				    		if (ship.sprite.position.y>300)
				    			config.game.timer -= timeused/42;
				    		else if (ship.sprite.position.y>250)
				    			config.game.timer -= timeused/15;
				    		else if (ship.sprite.position.y>200)
				    			config.game.timer -= timeused/10;
				    		else if (ship.sprite.position.y>100)
				    			config.game.timer -= timeused/7;
				    		else 
				    			config.game.timer -= timeused/3;
				    		//console.log(timeused/27 + ", " + config.game.timer);
					    	showTime();
				    	}
			    	}
			    	
			    	planet.render();		    	
			    	
			    }
			    
			    ship.render();

		    } else {
		    	
		    	if (!(config.game.action == ACTION_DONE)) {
		    		config.game.action = ACTION_DONE;
		    		
		    		space.hide();
		    		planet.hide();
		    		ship.hide();

	    			var mydiv = document.getElementById("smerf-timer");
	    			var css = mydiv.getAttribute("style");
	    			var style = 'width: 790px;font-size: 32px;color: #E77D59;padding: 12px 12px 0px 12px;';
	    			if (css === null) css = style;
	    			else css += style;
	    			mydiv.setAttribute("style", css);
		    		
		    		if (config.game.winning) {
		    			document.getElementById("smerf-timer").innerHTML =
		    				'<div style="font-size: 40px">Congratulations,<br> you have reached the carroty Planet Heaven that every conejo longs for.</div>' +
		    				"<br>" + '<div style="color: #007474;">' +
		    				"As it is three in the morning, i can barely keep my eyes open, i'd like to thank you" +
		    				"for taking the time to play this wouldbe game and see it for what it is, a nice thought" +
		    				"albeit not so nicely executed.<br>" +
		    				"I blame it on everything else but me :) good night/day now dear sir/madam, 'tis time...<br>" +
		    				"</div><br>" + '<a style="color: #70962E;display: inline;font-weight: 900;margin-left: 280px;" href="start.html">RESTART</a>';
		    		} else {
		    			document.getElementById("smerf-timer").innerHTML =
		    				"Congratulations,<br>you have reached the end of your path, your 10 seconds of hope are over," +
		    				"although i can only imagine what other adventures may lie ahead of you." +
		    				"<br>" + '<div style="color: #007474;">' +
		    				"As it is three in the morning, i can barely keep my eyes open, i'd like to thank you" +
		    				"for taking the time to play this wouldbe game and see it for what it is, a nice thought" +
		    				"albeit not so nicely executed.<br>" +
		    				"I blame it on everything else but me :) good night/day now dear sir/madam, 'tis time...<br>" +
		    				"</div><br>" + '<a style="color: #70962E;display: inline;font-weight: 900;margin-left: 280px;" href="start.html">RESTART</a>';
		    		}
		    	}
		    	
		    }
		    requestAnimFrame( animate );

		    // render the stage   
		    renderer.render(stage);
		    
		    if (dev)
		    	stats.end();
		    
		    config.frameno++;
		    
		}
	}