

var planet = {};

function stagePlanet() {

	planet.background = {};
	planet.background.obj = new PIXI.Graphics();

	var bkgr = planet.background.obj;
	stage.addChild(bkgr);
	bkgr.visible = false;
	
	bkgr.position.x = 0;
	bkgr.position.y = 0;
	
	if (config.debug.showBB)
		ship.shipdebug.clear();

	
	// creating space elipse
	bkgr.beginFill(config.planet.color.space);
	bkgr.drawElipse(config.pixi.canvas.width/2,100,config.planet.ellipse.width, config.planet.ellipse.height);
	bkgr.endFill();

	// creat high sky
	bkgr.beginFill(config.planet.color.skyhigh);
	bkgr.drawElipse(config.pixi.canvas.width/2,300,config.planet.ellipse.width, config.planet.ellipse.height);
	bkgr.endFill();
	
	// creat med sky
	bkgr.beginFill(config.planet.color.skymed);
	bkgr.drawElipse(config.pixi.canvas.width/2,500,config.planet.ellipse.width, config.planet.ellipse.height);
	bkgr.endFill();
	
	// creat low sky
	bkgr.beginFill(config.planet.color.skylow);
	bkgr.drawElipse(config.pixi.canvas.width/2,700,config.planet.ellipse.width, config.planet.ellipse.height);
	bkgr.endFill();

	// init the obstacles here because of the order
	planet.initObstacles();
	
	// now add the earth as a graphics child to overwrite the obstacles
	
	planet.background.mask = new PIXI.Graphics();

	var bkgr2 = planet.background.mask;
	planet.background.obj.addChild(bkgr2);
	bkgr2.visible = true;
	
	bkgr2.position.x = 0;
	bkgr2.position.y = 960;
	// creat grass
	bkgr2.beginFill(config.planet.color.surface);
	bkgr2.drawElipse(config.pixi.canvas.width/2,0,config.planet.ellipse.width, config.planet.ellipse.height);
	bkgr2.endFill();

	// creat planet
	bkgr2.beginFill(config.planet.color.earth);
	bkgr2.drawElipse(config.pixi.canvas.width/2,26,config.planet.ellipse.width, config.planet.ellipse.height);
	bkgr2.endFill();
}

planet.init = function() {
	
	planet.background.obj.visible = true;
	
	ship.sprite.rotation = Math.PI/2;
	ship.sprite.position.x = -30;
	ship.sprite.position.y = -30;
	ship.planet.zoomstep = 
	ship.sprite.scale = new PIXI.Point(0.6,0.6);
	ship.sprite.scale = new PIXI.Point(1,1);
	config.space.ship.rotation_curr = ship.sprite.rotation;
	
}

planet.initObstacles = function() {
	
	var no = 12;
	config.planet.obstacles.currentoffs = 0;
	
	
	for (i=0;i<2;i++) {
		config.planet.objects.wormholes[i] = {};
		config.planet.objects.wormholes[i].obj = new PIXI.Sprite.fromImage("assets/img/wormhole.png");
		planet.background.obj.addChild(config.planet.objects.wormholes[i].obj);
		config.planet.objects.wormholes[i].obj.offsety		= chance.natural({ min: 0, max: 80});
		config.planet.objects.wormholes[i].obj.position.y	= 720 - config.planet.objects.wormholes[i].obj.offsety;
		config.planet.objects.wormholes[i].posx = chance.natural({
			min: config.planet.obstacles.initoffs,
			max: config.planet.obstacles.initoffs + config.planet.obstacles.initspread});
		config.planet.objects.wormholes[i].obj.position.x = config.planet.objects.wormholes[i].posx;
		config.planet.objects.wormholes[i].posy  = config.planet.objects.wormholes[i].obj.position.y;
		config.planet.objects.wormholes[i].obj.pivot.x = 0;
		config.planet.objects.wormholes[i].obj.pivot.y = 0;
		config.planet.objects.wormholes[i].obj.anchor.x = 0;
		config.planet.objects.wormholes[i].obj.anchor.y = 0;
		config.planet.objects.wormholes[i].radius = 27;
		
		config.planet.objects.wormholes[i].collected = false;
		//console.log("x: " + config.planet.objects.wormholes[i].obj.position.x + ", y: " + config.planet.objects.wormholes[i].obj.position.y);
	}
	
	
	for (i=0;i<no;i++) {
		
		config.planet.obstacles.skyscraper[i] = {};
		config.planet.obstacles.skyscraper[i].obj = new PIXI.Sprite.fromImage("assets/img/skyscraper.png");
		
		planet.background.obj.addChild(config.planet.obstacles.skyscraper[i].obj);
		
		config.planet.obstacles.skyscraper[i].offset = chance.natural({ min: 0, max: 120});
		config.planet.obstacles.skyscraper[i].obj.position.y 	 = 720 - config.planet.obstacles.skyscraper[i].offset;
		config.planet.obstacles.skyscraper[i].posx	 	 = chance.natural({
										min: config.planet.obstacles.initoffs,
										max: config.planet.obstacles.initoffs + config.planet.obstacles.initspread});
		config.planet.obstacles.skyscraper[i].obj.position.x	 	 = config.planet.obstacles.skyscraper[i].posx;
		config.planet.obstacles.skyscraper[i].posy		= config.planet.obstacles.skyscraper[i].obj.position.y;
		config.planet.obstacles.skyscraper[i].obj.pivot.x = 0.5;
		config.planet.obstacles.skyscraper[i].obj.pivot.y = config.planet.obstacles.skyscraper[i].offset/config.planet.obstacles.skyscraper[i].obj.height;
	}
	
	
	config.planet.obstacles.offsety = [];
	config.planet.obstacles.rad = [];

	for (var i = 0; i < 500; i++) {
	    //xValues[i] = (400 + radius * Math.cos(2 * Math.PI * i / 10208));
	    config.planet.obstacles.offsety[i] = (1625 * Math.sin(Math.PI * i/ 40208));
	    //console.log(config.planet.obstacles.offsety[i]);
	    config.planet.obstacles.rad[i] = i*Math.PI/504;
	}
	
//	for (i=0;i<400;i++) {
//		config.planet.obstacles.offsety.y	=	 
//		config.planet.obstacles.offsety.rad	= 
//	}
	
//	planet.density.tree	
//	planet.density.plane
//	planet.density.bushes
	
}

planet.resetObstacle = function() {
	// config.planet.obstacles.skyscraper[i]
	
	
}

planet.renderObstacles = function() {
	
	config.planet.obstacles.currentoffs += config.planet.obstacles.scrollspeed;
		
//	if (dev) console.log(config.planet.obstacles.currentoffs);
	
	for (i=0; i<config.planet.obstacles.skyscraper.length;i++) {
		
		config.planet.obstacles.skyscraper[i].obj.position.x = config.planet.obstacles.skyscraper[i].posx - config.planet.obstacles.currentoffs;
		if (config.planet.obstacles.skyscraper[i].obj.position.x<400)
			config.planet.obstacles.skyscraper[i].obj.position.y = config.planet.obstacles.skyscraper[i].posy +
				config.planet.obstacles.offsety[500-config.planet.obstacles.skyscraper[i].obj.position.x-100];

		if ((config.planet.obstacles.skyscraper[i].obj.position.x>400) && (config.planet.obstacles.skyscraper[i].obj.position.x<800))
			config.planet.obstacles.skyscraper[i].obj.position.y = config.planet.obstacles.skyscraper[i].posy +
				config.planet.obstacles.offsety[config.planet.obstacles.skyscraper[i].obj.position.x-500+100];
		
		config.planet.obstacles.skyscraper[i].obj.rotation = config.planet.obstacles.rad[i];
		
		if (config.planet.obstacles.skyscraper[i].obj.position.x<config.planet.obstacles.resetbuffer) {
			config.planet.obstacles.skyscraper[i].posx = chance.natural({
				min: config.planet.obstacles.currentoffs + (config.planet.obstacles.initspread-config.planet.obstacles.initoffs),
				max: config.planet.obstacles.currentoffs + (config.planet.obstacles.initspread-config.planet.obstacles.initoffs)+config.planet.obstacles.initspread});
		}
	}
	
	for (i=0; i<config.planet.objects.wormholes.length;i++) {
		
		if (config.frameno%2==0) {
			config.planet.objects.wormholes[i].obj.rotation -= 0.2;
		}
		
		config.planet.objects.wormholes[i].obj.position.x = config.planet.objects.wormholes[i].posx - config.planet.obstacles.currentoffs;		

		if (config.planet.objects.wormholes[i].obj.position.x<config.planet.obstacles.resetbuffer) {
			if (config.planet.objects.wormholes[i].collected) {
				config.planet.objects.wormholes[i].collected = false;
				config.planet.objects.wormholes[i].obj.visible = true;
			}
			config.planet.objects.wormholes[i].posx = chance.natural({
				min: config.planet.obstacles.currentoffs + (config.planet.obstacles.initspread-config.planet.obstacles.initoffs),
				max: config.planet.obstacles.currentoffs + (config.planet.obstacles.initspread-config.planet.obstacles.initoffs)+config.planet.obstacles.initspread});
		}

	}
	
	
}

planet.hide = function() {
	planet.background.obj.visible = false;
}

planet.setAlpha = function(val) {
	planet.background.obj.alpha = val;
}

planet.render = function() {
	
	if (config.game.action == ACTION_INTRO) {

		// move the ship into position, then start game
		if (!ship.planet.moveTo(400,250,4)) {		// NOT means not moving anymore
			config.game.action = ACTION_PLAY;
			config.planet.ship.started = true;
//			planet.hide();
		} else {
			if (ship.sprite.scale.x > config.planet.ship.scale) {
				//console.log("scaling");
				ship.sprite.scale.x -= 0.006;
				ship.sprite.scale.y -= 0.006;
			}
			if (planet.background.obj.position.y > -326)
				planet.background.obj.position.y -= 4;
			else planet.background.obj.position.y = -326;
		}
	} else if (config.game.action == ACTION_PLAY) {
		
		// MAIN PLAY LOOP
		
		if (ship.sprite.position.y <= 26) {
			config.game.action = ACTION_OUTTRO;
			config.planet.ship.started = false;
		}
		
		
		planet.renderObstacles();
		
		
		
	} else if (config.game.action == ACTION_OUTTRO) {
		if (!ship.planet.moveTo(980,26,4)) {
			
			config.game.action = ACTION_PAUSE;
			planet.hide();
			config.planet.alpha = 1;
			planet.setAlpha(config.planet.alpha);
			config.game.maptype = MAPTYPE_SPACE;
			config.game.action = ACTION_LIFTOFF;
			space.activate();
			
		} else {
			if (ship.sprite.scale.x<1) {
				//console.log("scaling");
				ship.sprite.scale.x += 0.006;
				ship.sprite.scale.y += 0.006;
			}
		if (planet.background.obj.position.y < 0)
				planet.background.obj.position.y += 4;
			else planet.background.obj.position.y = 0;
		}
		
//		config.planet.alpha -= 0.01;
//		planet.setAlpha(config.planet.alpha);
	}

}