
var ship = {
		"planet" : {}
};

var current_speed = new PIXI.Point(0,0);
var movement_speed = new PIXI.Point(0,0);
var new_speed = new PIXI.Point(0,0);

function stageShip() {
	// ship.texture = PIXI.Texture.fromImage("assets/img/ship.png");
	
	ship.BBox = {
			"polygon" : {
				"original" : {},
				"transformed" : {}
			}
	};
	
	// create a new Sprite using the texture
	ship.sprite = new PIXI.Sprite.fromImage("assets/img/ship.png");
	
	ship.zoom = new PIXI.Point(config.space.ship.zoom, config.space.ship.zoom);

	ship.planetContact = 0;
	
	// center the sprites anchor point
	ship.sprite.anchor.x = 0.5;
	ship.sprite.anchor.y = 0.5;
	
	// move the sprite t the center of the screen
	ship.sprite.position.x = 200;
	ship.sprite.position.y = 150;
	
	// shrink it a bit
	ship.sprite.scale = ship.zoom;

	ship.move = function(dx, dy) {
	
		// TODO: collision checks and such
		
		ship.sprite.position.x += dx;
		ship.sprite.position.y += dy;
	}
	
	ship.exhaust0 = new PIXI.Sprite.fromImage("assets/img/ship_exhaust_orange.png");
	ship.sprite.addChild(ship.exhaust0);
	ship.exhaust0.position.x = -52;
	ship.exhaust0.position.y = 81;
	
	ship.exhaust1 = new PIXI.Sprite.fromImage("assets/img/ship_exhaust_yellow.png");
	ship.sprite.addChild(ship.exhaust1);
	ship.exhaust1.position.x = -52;
	ship.exhaust1.position.y = 81;
	
	if (dev) {
		// add the movement vectors for the ship
		ship.movementvectors = new PIXI.Graphics();
		stage.addChild(ship.movementvectors);
		ship.movementvectors.position.x = 620/2;
		ship.movementvectors.position.y = 380/2;
	}
	
	
	ship.animateExhaust = function() {
		// toggle exhaust image order, slow, but no other way ATM, swapCh
		if (config.frameno%4==0) {
			
			if (config.exhausttype == 0) {
				ship.sprite.removeChild(ship.exhaust0);
				ship.sprite.removeChild(ship.exhaust1);
	
				if (config.exhaustimg==0) {
					ship.sprite.addChild(ship.exhaust0);
					ship.sprite.addChild(ship.exhaust1);
					config.exhaustimg = 1;
				} else {
					ship.sprite.addChild(ship.exhaust1);
					ship.sprite.addChild(ship.exhaust0);
					config.exhaustimg = 0;	
				}
			} else {
				if (config.exhaustimg==0) {
					ship.sprite.removeChild(ship.exhaust0);
					ship.sprite.addChild(ship.exhaust1);
					config.exhaustimg = 1;
				} else {
					ship.sprite.removeChild(ship.exhaust1);
					ship.sprite.addChild(ship.exhaust0);
					config.exhaustimg = 0;	
				}
			}
		}
		
		// make some simple exhaust animation
		var alph = config.space.ship.speed_accaccu*13;
		if (alph>1) alph = 1;
		ship.exhaust0.alpha = alph;
		ship.exhaust1.alpha = alph;
		
	}
	
	
	ship.showBB = function() {
		ship.shipdebug.position.x = ship.sprite.position.x;
		ship.shipdebug.position.y = ship.sprite.position.y;
		
		ship.shipdebug.clear();
		ship.shipdebug.lineStyle(1, 0x00ff00, 1);
		ship.shipdebug.beginFill(0);
		
		ship.shipdebug.moveTo(
				ship.BBox.polygon.transformed.local[0].x,
				ship.BBox.polygon.transformed.local[0].y);
		ship.shipdebug.lineTo(
				ship.BBox.polygon.transformed.local[1].x,
				ship.BBox.polygon.transformed.local[1].y);
		ship.shipdebug.lineTo(
				ship.BBox.polygon.transformed.local[2].x,
				ship.BBox.polygon.transformed.local[2].y);
		ship.shipdebug.lineTo(
				ship.BBox.polygon.transformed.local[3].x,
				ship.BBox.polygon.transformed.local[3].y);
		ship.shipdebug.lineTo(
				ship.BBox.polygon.transformed.local[0].x,
				ship.BBox.polygon.transformed.local[0].y);
		ship.shipdebug.endFill();
		
		ship.shipdebug.beginFill(0x0000ff);
		ship.shipdebug.lineStyle(0);
		for (i=0;i<6;i++) {
			ship.shipdebug.drawCircle(
					ship.BBox.polygon.transformed.local[i].x,
					ship.BBox.polygon.transformed.local[i].y,
					3);
		}
		ship.shipdebug.endFill();
			
	}
	
	ship.render = function() {
		
		if (dev)
		if (config.frameno%20==0) {
			console.log("ShipX: " + ship.sprite.position.x + ", ShipY: " + ship.sprite.position.y);
		}
		
		if (!config.space.pause) {
			
			ship.rotateBB();
			
			ship.processMovement();
	
			ship.animateExhaust();
	
			if (config.debug.showBB)
				ship.showBB();
			if (config.debug.showMovement)
				ship.debugMovementVector();
			
		}
		
		if (config.game.maptype == MAPTYPE_PLANET) {
			config.space.ship.speed_accaccu = 0.5;
			// config.exhausttype = 0; doesn't work, error when trying to remove the nonexisting child
			ship.rotateBB();
			ship.checkWormholeCollision();
			
			ship.animateExhaust();
		}
	}
	
	ship.initBB = function() {
		ship.BBox.polygon.original = [
				new PIXI.Point(
							ship.sprite.position.x - ship.sprite.anchor.x * ship.sprite.width,
							ship.sprite.position.y - ship.sprite.anchor.y * ship.sprite.height),
				new PIXI.Point(
							ship.sprite.position.x + ship.sprite.anchor.x * ship.sprite.width,
							ship.sprite.position.y - ship.sprite.anchor.y * ship.sprite.height),
				new PIXI.Point(
							ship.sprite.position.x + ship.sprite.anchor.x * ship.sprite.width,
							ship.sprite.position.y + ship.sprite.anchor.y * ship.sprite.height),
				new PIXI.Point(
							ship.sprite.position.x - ship.sprite.anchor.x * ship.sprite.width,
							ship.sprite.position.y + ship.sprite.anchor.y * ship.sprite.height),
		];
		ship.BBox.polygon.transformed = {};
		ship.BBox.polygon.transformed.local = [
				new PIXI.Point(0,0),
				new PIXI.Point(0,0),
				new PIXI.Point(0,0),
				new PIXI.Point(0,0),
				new PIXI.Point(0,0),
				new PIXI.Point(0,0)
		];
		ship.BBox.polygon.transformed.world = [
   				new PIXI.Point(0,0),
   				new PIXI.Point(0,0),
   				new PIXI.Point(0,0),
   				new PIXI.Point(0,0),
   				new PIXI.Point(0,0),		// two helper points to alleviate the problem with the side contact
   				new PIXI.Point(0,0)			// this way i can still use my poor mans collision detection w/o too much impact
   		];
		ship.BBox.center = new PIXI.Point(0,0);
		
		if (config.debug.showBB) {
			ship.shipdebug = new PIXI.Graphics();
			stage.addChild(ship.shipdebug);
		}
	}

	
	
	ship.planet.moveTo = function(mx, my, speed) {
		
		//if (dev) console.log("sx: " + ship.sprite.position.x + ", x: " + mx + ",  sy: " + ship.sprite.position.y + ", y: " + my);
		
		if ((ship.sprite.position.x == mx) && (ship.sprite.position.y == my)) {
			config.planet.movingTo = false;
			return false;
		}
		
		var dist = calcDistance(mx, my, ship.sprite.position.x, ship.sprite.position.y);
		if (dist<speed) {
			ship.sprite.position.x = mx;
			ship.sprite.position.y = my;
			config.planet.movingTo = false;
			return false;
		}
		
		var ratio = speed/dist;
		
		//if (dev) console.log("ratio: " + ratio + ", speed: " + speed + ", dist: " + dist);
		
		ship.sprite.position.x -= (ship.sprite.position.x - mx) * ratio;
		ship.sprite.position.y -= (ship.sprite.position.y - my) * ratio;
		
		config.planet.movingTo = true;
		return true;
	}
	
	
	ship.rotateBBPoint = function(no) {
		
		// get current original boxes world coords
		ship.BBox.polygon.original[no].x =
			ship.sprite.position.x + (ship.sprite.anchor.x * ship.sprite.width * ( (no==0||no==3) ? -1 : 1 ) * ( (no==0||no==1) ? 0.3 : 1.1 ));
		ship.BBox.polygon.original[no].y =
			ship.sprite.position.y + (ship.sprite.anchor.y * ship.sprite.height * ( (no==0||no==1) ? -1 : 1 ));
		
		// move to sprite coordinates
		ship.BBox.polygon.original[no].x -= ship.BBox.center.x;
		ship.BBox.polygon.original[no].y -= ship.BBox.center.y;

		// rotate
		ship.BBox.polygon.transformed.local[no].x = ship.BBox.polygon.original[no].x * ship.BBox.cos - ship.BBox.polygon.original[no].y * ship.BBox.sin,
		ship.BBox.polygon.transformed.local[no].y = ship.BBox.polygon.original[no].x * ship.BBox.sin + ship.BBox.polygon.original[no].y * ship.BBox.cos;

		// move to word cooridinates
		ship.BBox.polygon.transformed.world[no].x = ship.BBox.polygon.transformed.local[no].x + ship.BBox.center.x;
		ship.BBox.polygon.transformed.world[no].y = ship.BBox.polygon.transformed.local[no].y + ship.BBox.center.y;

	}
	
	// rotates the points of the bounding box to match the sprites rotation
	ship.rotateBB = function() {
		
		ship.BBox.cos = Math.cos(ship.sprite.rotation);
		ship.BBox.sin = Math.sin(ship.sprite.rotation);
		
		ship.BBox.center.x = ship.sprite.position.x;
		ship.BBox.center.y = ship.sprite.position.y;
		
		for (i=0;i<4;i++)
			ship.rotateBBPoint(i);
		
		// now set the side helper points
		// right side
		ship.BBox.polygon.transformed.world[4].x =
				ship.BBox.polygon.transformed.world[1].x
			+ 	(ship.BBox.polygon.transformed.world[2].x - ship.BBox.polygon.transformed.world[1].x)/2;
		ship.BBox.polygon.transformed.world[4].y = 
				ship.BBox.polygon.transformed.world[1].y
			+ 	(ship.BBox.polygon.transformed.world[2].y - ship.BBox.polygon.transformed.world[1].y)/2;
		ship.BBox.polygon.transformed.local[4].x = ship.BBox.polygon.transformed.world[4].x - ship.BBox.center.x;
		ship.BBox.polygon.transformed.local[4].y = ship.BBox.polygon.transformed.world[4].y - ship.BBox.center.y;
		
		// left side
			ship.BBox.polygon.transformed.world[5].x =
				ship.BBox.polygon.transformed.world[0].x
			+ 	(ship.BBox.polygon.transformed.world[3].x - ship.BBox.polygon.transformed.world[0].x)/2;
		ship.BBox.polygon.transformed.world[5].y = 
				ship.BBox.polygon.transformed.world[0].y
			+ 	(ship.BBox.polygon.transformed.world[3].y - ship.BBox.polygon.transformed.world[0].y)/2;
		ship.BBox.polygon.transformed.local[5].x = ship.BBox.polygon.transformed.world[5].x - ship.BBox.center.x;
		ship.BBox.polygon.transformed.local[5].y = ship.BBox.polygon.transformed.world[5].y - ship.BBox.center.y;
	}
	
	
	ship.checkPlanetCollision = function() {
		
		// TODO: make a collision detection by creating a set of triangles representing the ship,
		// then make triangle->circle collision detection
		// or maybe just by using a polygon and test all the points if they are inside the circle
		
		var dist = 0;
		var planet = null;
		var shippoint = null;
		
		for (i=0;i<config.space.planets.count;i++) {

			planet = config.space.planets.list[i];
			
			for (g=0;g<ship.BBox.polygon.transformed.world.length;g++) {
				
				shippoint = ship.BBox.polygon.transformed.world[g];
				
				//       sqrt   (            a^2                        +                 b^2                   )
				dist = Math.sqrt(
								Math.pow(Math.abs(planet.posx-shippoint.x),2)
							+ 	Math.pow(Math.abs(planet.posy-shippoint.y),2)
						);
				
				// if (dev) console.log("D: " + dist + ", R: " + planet.radius);
				
				if (dist<planet.radius) {
					ship.planetContact = i;
					config.space.pause = true;
					config.planetContact = i;
					if (dev) console.log("OHOHOOHHOHOOO: Collision with planet no. " + ship.planetContact);
					break;
				}
				
			}
		}
		
		ship.planetContact = 0;
	}
	
ship.checkWormholeCollision = function() {
		
		var dist = 0;
		var wormhole = null;
		var shippoint = null;
		
		for (i=0;i<config.planet.objects.wormholes.length;i++) {

			wormhole = config.planet.objects.wormholes[i];

			for (g=0;g<ship.BBox.polygon.transformed.world.length;g++) {

				shippoint = ship.BBox.polygon.transformed.world[g];
				
				//       sqrt   (            a^2                        +                 b^2                   )
				dist = Math.sqrt(
								Math.pow(Math.abs(wormhole.obj.position.x-shippoint.x),2)
							+ 	Math.pow(Math.abs(wormhole.obj.position.y-326-shippoint.y),2)
						);

				if (config.frameno%60==0) {
					if (dev) {
						console.log("D: " + dist + ", R: " + wormhole.radius);
						console.log("Xw: " + (wormhole.obj.position.x) + ", Xs: " + shippoint.x);
						console.log("Yw: " + (wormhole.obj.position.y-326) + ", Yz: " + shippoint.y);
					}
				}

				if (dist<wormhole.radius && !wormhole.collected) {
					config.game.timer += config.planet.timePerWormhole;
					wormhole.collected = true;
					wormhole.obj.visible = false;
					// TODO: some nice anim (move it to the timer or sth., shakin' the ship, ...)
					if (dev)
						console.log("OHOHOOHHOHOOO: Gotme summn' ");
				}
				
			}
		}
	}
	
	
	
	ship.setAlpha = function(val) {
		ship.sprite.alpha = val;
	}
	
	ship.hide = function() {
		ship.sprite.visible = false;
	}
	
	ship.show = function() {
		ship.sprite.visible = true;
		ship.setAlpha(1);
	}

	
	/**
	 * Uses the current speed to calculate the next position if ship is moving
	 */
	ship.processMovement = function() {
		
		if (config.game.maptype == MAPTYPE_SPACE) {
			
			if (config.space.ship.started) {	// see if we have left the planet yet

				var oldpos = ship.sprite.position;
				
				ship.move(
						Math.sin(config.space.ship.rotation_curr)*config.space.ship.speed,
						-Math.cos(config.space.ship.rotation_curr)*config.space.ship.speed);
				
				var boundary_collision = false;
				
				if (ship.sprite.position.x < config.space.movement.minx) {
					ship.sprite.position.x = config.space.movement.minx;
					boundary_collision = true;
				}
				if (ship.sprite.position.x > config.space.movement.maxx) {
					ship.sprite.position.x = config.space.movement.maxx;
					boundary_collision = true;
				}
				if (ship.sprite.position.y < config.space.movement.miny) {
					ship.sprite.position.y = config.space.movement.miny;
					boundary_collision = true;
				}
				if (ship.sprite.position.y > config.space.movement.maxy) {
					ship.sprite.position.y = config.space.movement.maxy;
					boundary_collision = true;
				}
				if (boundary_collision) {
					config.space.ship.speed = 0;
					//config.space.ship.rotation_curr = ship.sprite.rotation;
				}
				
				if (config.frameno%30==0) {
					if (dev) 
					{
						console.log("Started: " + config.space.ship.started + ", MType: " + config.game.maptype + ", Action: " + config.game.action);
					}
				}
				
				// check winning
				if (
						(ship.sprite.position.x > (config.space.world.width-60))
					&&  (ship.sprite.position.y < (60)) && config.game.action!=ACTION_LIFTOFF) {
					if (dev) {
				    	console.log("Started: " + config.space.ship.started + ", MType: " + config.game.maptype + ", Action: " + config.game.action);
				    	console.log("Loosing: " + config.game.loosing + ", Winning: " + config.game.winning);
					}
					config.game.winning = true;
				}
				
				ship.checkPlanetCollision();
				
				if (ship.planetContact!=0) {
					if (dev) {
						console.log("Ship Contact Planet No.: " + config.planetContact);
					}
				}
				
				if (!config.space.ship.accelerating && config.space.ship.speed>0) {
					config.space.ship.speed -= config.space.ship.speed_dec;
					if (config.space.ship.speed<0)
						config.space.ship.speed = 0;
				}
				
//				if (dev && config.space.ship.speed!=0) { 
//					//console.log("processMovement->SPEED: " + config.space.ship.speed + "ACC: " +
//					//		(config.space.ship.accelerating?"TRUE":"FALSE"));
//				}
			}

		} else if (config.game.maptype == MAPTYPE_PLANET) {
			
//			ship.checkWormholeCollision();
			
		}
		
	}


	function calculateNewMove() {
		
		current_speed = new PIXI.Point(
				Math.sin(config.space.ship.rotation_curr)*config.space.ship.speed,
				Math.cos(config.space.ship.rotation_curr)*config.space.ship.speed);
		
		movement_speed = new PIXI.Point(
				Math.sin(ship.sprite.rotation)*config.space.ship.speed_accaccu,
				Math.cos(ship.sprite.rotation)*config.space.ship.speed_accaccu);
				
		new_speed = new PIXI.Point(
				current_speed.x + movement_speed.x,
				current_speed.y + movement_speed.y);
		
		
		config.space.ship.rotation_curr = Math.atan2(new_speed.x,new_speed.y);
		
		config.space.ship.speed = Math.sqrt(Math.pow(new_speed.y,2)+Math.pow(new_speed.x,2));

		
		if (dev) {
			//console.log("Old: (s: " + config.space.ship.speed + ", a: " + config.space.ship.rotation_curr + ")");
			//console.log("New: (s: " + Math.sqrt(Math.pow(current_speed.y,2)+Math.pow(current_speed.x,2)) + ", a: " + Math.atan2(current_speed.y,current_speed.x) + ") ");
//			console.log("Old: (s: " + config.space.ship.speed_acc + ", a: " + ship.sprite.rotation + ")");
//			console.log("New: (s: " + Math.sqrt(Math.pow(movement_speed.y,2)+Math.pow(movement_speed.x,2)) + ", a: " + Math.atan2(movement_speed.y,movement_speed.x) + ") ");
//			console.log(
//					"Curr: (" + current_speed.x + ", " + current_speed.y + "), " +
//					"Mov: (" + movement_speed.x + ", " + movement_speed.y + "), " + 
//					"New: (" + new_speed.x + ", " + new_speed.y + "), " +
//					"Speed: " + config.space.ship.speed);
		}
		
	}
	
	// called by space and up arrow, depending on situation
	ship.accelerate = function() {
		
		config.space.ship.accelerating = true;
		
		config.space.ship.speed_accaccu += config.space.ship.speed_acc;
		
		calculateNewMove();
		
		if (config.space.ship.speed > config.space.ship.speed_max) {
			config.space.ship.speed = config.space.ship.speed_max;
			config.space.ship.started = true;
		}
			//config.space.ship.speed += config.space.ship.speed_acc;
			
			//if (dev) console.log("ship.accelerate->SPEED: " + config.space.ship.speed);
//		} else {
//			// we reached maximum acceleration, so force start
//			config.space.ship.started = true;
//		}
		
		// TODO: show current velocity, add exhaust animationto reflect it
	}
	
	
	

// UP
	function keyUPdown(e)    {
		if (config.game.maptype == MAPTYPE_SPACE) {
			ship.accelerate();
		} else if (config.game.maptype == MAPTYPE_PLANET) {
			if (config.planet.ship.started)
				ship.move(0, -config.planet.ship.movement_speed);
		}
	}

	function keyUPup(e) {
		if (config.game.maptype == MAPTYPE_SPACE) {
			config.space.ship.accelerating = false;
			config.space.ship.speed_accaccu = 0;
			if (!config.space.ship.started) {
				config.space.ship.started = true;
			}
		}
	}


// DOWN
	function keyDOWN(e)  {
		if (config.game.maptype == MAPTYPE_SPACE) {

		} else if (config.game.maptype == MAPTYPE_PLANET) {

			if (config.planet.ship.started && ship.sprite.position.y<446)
				ship.move(0, config.planet.ship.movement_speed);
			
		}
	}

	

// LEFT
	function keyLEFT(e)  {
		if (config.game.maptype == MAPTYPE_SPACE) {
			if (config.space.ship.started)
				ship.sprite.rotation -= config.space.ship.rotation_speed;
		} else if (config.game.maptype == MAPTYPE_PLANET) {

			if (config.planet.ship.started && ship.sprite.position.x>config.space.movement.minx)
				ship.move(-config.planet.ship.movement_speed,0);
			
		}
	}

	
// RIGHT
	function keyRIGHT(e) {
		if (config.game.maptype == MAPTYPE_SPACE) {
			if (config.space.ship.started)
				ship.sprite.rotation += config.space.ship.rotation_speed;
		} else if (config.game.maptype == MAPTYPE_PLANET) {

			if (config.planet.ship.started && ship.sprite.position.x<config.space.movement.maxx)
				ship.move(config.planet.ship.movement_speed,0);

		}
	}
	
// SPACE
	function keySPACEdown(e) {

		if (config.game.maptype == MAPTYPE_SPACE) {
			
			if (!config.space.ship.started) {	// only at the beginning we use space to start
				ship.accelerate();
			}

		} else if (config.game.maptype == MAPTYPE_PLANET) {
			
		}
		
	}
	
	function keySPACEup(e) {
		if (config.game.maptype == MAPTYPE_SPACE) {
			if (!config.space.ship.started) {
				config.space.ship.started = true;
				config.space.ship.accelerating = false;
				config.space.ship.speed_accaccu = 0;
			}
		}
	}
	
	// game loop optimized keyboard handling
	kd.UP.down(keyUPdown);
	kd.UP.up(keyUPup);
	
	kd.DOWN.down(keyDOWN);
	
	kd.LEFT.down(keyLEFT);
	
	kd.RIGHT.down(keyRIGHT);
	
	kd.SPACE.down(keySPACEdown);
	kd.SPACE.up(keySPACEup);	

	ship.initBB();
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	ship.debugMovementVector = function() {
	
		ship.movementvectors.position.x = ship.sprite.position.x;
		ship.movementvectors.position.y = ship.sprite.position.y;
		
		ship.movementvectors.position.x = 100;
		ship.movementvectors.position.y = 100;
	
	
		ship.movementvectors.clear();
		ship.movementvectors.beginFill(0xFF0000);
		ship.movementvectors.lineStyle(3, 0xff0000, 1);
	
		ship.movementvectors.moveTo(0, 0);
	
		ship.movementvectors.lineTo(
				Math.sin(ship.sprite.rotation)*100,
				-Math.cos(ship.sprite.rotation)*100);
		
	//console.log("HERE: " + config.space.ship.rotation_curr);
	
		ship.movementvectors.lineStyle(3, 0x00ff00, 1);
		ship.movementvectors.moveTo(0, 0);
		ship.movementvectors.lineTo(
				Math.sin(config.space.ship.rotation_curr)*75,
				-Math.cos(config.space.ship.rotation_curr)*75);
	
		// current
		ship.movementvectors.lineStyle(3, 0x00ff00, 1);
		ship.movementvectors.moveTo(0, 0);
		ship.movementvectors.lineTo(
				current_speed.x*400,
				-current_speed.y*400);
		
		// new_speed
		ship.movementvectors.lineStyle(3, 0x0000ff, 1);
		ship.movementvectors.moveTo(0, 0);
		ship.movementvectors.lineTo(
				new_speed.x*400,
				-new_speed.y*400);
	}

}

function calcDistance(x1, y1, x2, y2) {
	return Math.sqrt(
				Math.pow(Math.abs(x1-x2),2)
			+ 	Math.pow(Math.abs(y1-y2),2)
		);
}

