// space setup


var space = {};

function stageSpace() {
	
	stage.setBackgroundColor(config.space.bkgrcolor);
	
	ship.sprite.rotation = config.space.planet.shiprotation;
	config.space.ship.rotation_curr = ship.sprite.rotation;
	
	ship.sprite.position.x = config.space.planet.radius.earth - config.space.planet.shipoffset;
	ship.sprite.position.y = config.pixi.canvas.height - config.space.planet.radius.earth + config.space.planet.shipoffset;
	
// STARTPLANET

	// add the movement vectors for the ship
	space.startplanet = new PIXI.Graphics();
	stage.addChild(space.startplanet);
	space.startplanet.position.x = - config.space.planet.radius.skymed;
	space.startplanet.position.y = config.pixi.canvas.height - config.space.planet.radius.skymed;

	space.startplanet.clear();

	// skymed
	space.startplanet.beginFill(config.space.planet.color.skymed, config.space.planet.color.skymedalpha);
	//space.startplanet.lineStyle(1, config.space.planet.color.skymed, 0.5);
	space.startplanet.lineStyle(1, config.space.planet.color.skymedalias, config.space.planet.color.skymedaliasalpha);
	space.startplanet.drawCircle(
			config.space.planet.radius.skymed, config.space.planet.radius.skymed,
			config.space.planet.radius.skymed);

	// skylow
	space.startplanet.beginFill(config.space.planet.color.skylow, config.space.planet.color.skylowalpha);
	space.startplanet.lineStyle(1, config.space.planet.color.skylowalias, config.space.planet.color.skylowaliasalpha);
	space.startplanet.drawCircle(
			config.space.planet.radius.skymed, config.space.planet.radius.skymed,
			config.space.planet.radius.skylow);
	
	// planet
	space.startplanet.beginFill(config.space.planet.color.earth, config.space.planet.color.earthalpha);
	space.startplanet.lineStyle(1, config.space.planet.color.earthalias, config.space.planet.color.earthaliasalpha);
	space.startplanet.drawCircle(
			config.space.planet.radius.skymed, config.space.planet.radius.skymed,
			config.space.planet.radius.earth);

	
// TARGET
	
	// add the movement vectors for the ship
	space.targetplanet = new PIXI.Graphics();
	stage.addChild(space.targetplanet);
	space.targetplanet.position.x = config.space.world.width - config.space.target.radiusskymed*2 - 10;
	space.targetplanet.position.y = 10;

	space.targetplanet.clear();
	
	// skymed
	space.targetplanet.beginFill(config.space.target.color.skymed, config.space.target.color.skymedalpha);
	space.targetplanet.lineStyle(1, config.space.target.color.skymedalias, config.space.target.color.skymedaliasalpha);
	space.targetplanet.drawCircle(
			config.space.target.radiusskymed, config.space.target.radiusskymed,
			config.space.target.radiusskymed);
	
	// planet
	space.targetplanet.beginFill(config.space.target.color.earth, config.space.target.color.earthalpha);
	space.targetplanet.lineStyle(1, config.space.target.color.earthalias, config.space.target.color.earthaliasalpha);
	space.targetplanet.drawCircle(
			config.space.target.radiusskymed, config.space.target.radiusskymed,
			config.space.target.radiusearth);
	
	// small planets
	generatePlanets();
	
}


space.activate = function() {
	config.space.pause = false;
	space.setAlpha(1);
	config.space.hidden = false;
	space.show();
	config.space.alpha = 1;
}

function generatePlanets() {
	
	// WTF, the placement is seriously broken. even though i try to move the misplaced plante away from the
	// colliding one, it times out every time. There has to be some simple logic fault... no time left...
	// TODO: AFTER LD: fix planet placement, good enough for now
	
	var placementattempt = 0;
	var placerecursion = 0;
	
	function tooClose(plano) {

		if (placementattempt>=config.space.planets.distmaxtry)
			return true;

		// check for boundaries
		if (	
				(config.space.planets.list[plano].posx < config.space.movement.minx)
			||	(config.space.planets.list[plano].posy < config.space.movement.miny)
			||	(config.space.planets.list[plano].posx > (config.space.world.width - config.space.movement.minx))
			||	(config.space.planets.list[plano].posy > (config.space.world.height - config.space.movement.minx))
			)
				return true;

		// keep start area clear
		if (	(config.space.planets.list[plano].posx
				  <	(config.space.planet.radius.earth+config.space.planet.radius.skylow))
			&&	(config.space.planets.list[plano].posy
				  >	(config.space.world.height-config.space.planet.radius.earth - config.space.planet.radius.skylow)) 
			) 
		{
			placementattempt++;	
			return true;
		}

		// keep target area clear
		if (	(config.space.planets.list[plano].posx
				  >	(config.space.world.width - config.space.target.radiusskymed*2))
			&&	(config.space.planets.list[plano].posy
				  <	(config.space.target.radiusskymed*2))
			) 
		{
			placementattempt++;	
			return true;
		}

		//return false;
		
		// prevent from overlapping
		var dist = 0;
		var distx = 0;
		var disty = 0;
		var p0 = config.space.planets.list[plano];
		for (h=0;h<plano;h++) {
			var p1 = config.space.planets.list[h];
			//if (dev) 
			//	console.log("    h: " + h + ", P1: (" + p1.posx + ", " + p1.posy + ")");
			
			//       sqrt   (            a^2                        +                 b^2                   )
			dist = Math.sqrt( Math.pow(Math.abs(p0.posx-p1.posx),2) + Math.pow(Math.abs(p0.posx-p1.posx),2) );
			
//			if (dev)
//				console.log("a: " + (Math.abs(p0.posx-p1.posx)) + ", a^2: " + (Math.pow(Math.abs(p0.posx-p1.posx),2)));
			
			if (dist<config.space.planets.mindist) {
				//if (dev) 
				//	console.log("r: " + placerecursion + ", A: " + placementattempt + ", D: " + dist + ", P0: (" + p0.posx + ", " + p0.posy + "), P1: (" + p1.posx + ", " + p1.posy + ")");
				placementattempt++;
				
				// now try to move it a bit away from the current planet
				if (placerecursion<config.space.planets.distmaxrec) {
					//if (dev) 
					//	console.log("dX: " + Math.abs(p0.posx-p1.posx) + ", dY: " + Math.abs(p0.posy-p1.posy));
					config.space.planets.list[plano].posx -= (p1.posx-p0.posx);
					config.space.planets.list[plano].posy -= (p1.posy-p0.posy);
					placerecursion++;
					return tooClose(plano);
				} else {
					placerecursion = 0;
					return true;
				}
			}
		}
		
		
		placementattempt = 0;
		return false;
	}

	for (i=0;i<config.space.planets.density;i++) {
		
		placementattempt = 0;
		
		config.space.planets.list[i] = {};
		var planet = config.space.planets.list[i];
		
		planet.obj = new PIXI.Graphics();
		
		// RADIUS
		planet.radius = config.space.planets.minsize + Math.random()*(config.space.planets.maxsize-config.space.planets.minsize);
		
		// BORDER
		planet.border = config.space.planets.minborder + Math.random()*(config.space.planets.maxborder-config.space.planets.minborder);
		
		// PROPERTIES
//		var fourth = Math.ceil(config.planet.maxobstacles/2);
//		planet.density.house	= chance.natural({ min: 0, max: fourth}); 
//		planet.density.tree		= chance.natural({ min: 0, max: fourth});
//		planet.density.plane	= chance.natural({ min: 0, max: fourth});
//		planet.density.bushes	= chance.natural({ min: 0, max: fourth});
//		
		// TODO: more planet types
		
		do {
			planet.posx = chance.natural({
					min: config.space.movement.minx,
					max: (config.space.world.width - config.space.movement.minx)
				});
			planet.posy = chance.natural({
				min: config.space.movement.miny,
				max: (config.space.world.height - config.space.movement.miny)
			});

			//if (dev) console.log("A: " + placementattempt);
		} while (
					// failsafe for infinite loop, not perfect, would be better to have better placement,
					// but good enough for now
					(placementattempt<config.space.planets.distmaxtry)
					// check if we can place it
				&&	tooClose(i) 
				);
		
		if (placementattempt>=config.space.planets.distmaxtry) {
			config.space.planets.list.pop();
			break;
		}
		
		// init to stage
		stage.addChild(planet.obj);
		planet.obj.position.x = planet.posx;
		planet.obj.position.y = planet.posy;
		
		// prepare for painting
		planet.obj.clear();
		planet.obj.beginFill(config.space.planet.color.earth);
		planet.obj.lineStyle(planet.border, config.space.planet.color.skymed, 1);
		
		// skymed
		planet.obj.beginFill(config.space.planet.color.skymed, config.space.planet.color.skymedalpha);
		planet.obj.lineStyle(1, config.space.planet.color.skymedalias, config.space.planet.color.skymedaliasalpha);
		planet.obj.drawCircle(0,0, planet.radius + planet.border);
		planet.obj.endFill();
		
		// earth
		planet.obj.beginFill(config.space.planet.color.earth, config.space.planet.color.earthalpha);
		planet.obj.lineStyle(1, config.space.planet.color.earthalias, config.space.planet.color.earthaliasalpha);
		planet.obj.drawCircle(0,0, planet.radius);
	}
	
	config.space.planets.count = config.space.planets.list.length;

	if (dev) console.log("Planets: " + config.space.planets.count);
}



space.setAlpha = function(val) {
	// hide all the assets we have
	for (i=0;i<config.space.planets.count;i++) {
		config.space.planets.list[i].obj.alpha = val;
	}
	space.targetplanet.alpha = val;
	space.startplanet.alpha = val;
}

space.hide = function() {
	// hide all the assets we have
	for (i=0;i<config.space.planets.count;i++) {
		config.space.planets.list[i].obj.visible = false;
	}
	space.targetplanet.visible = false;
	space.startplanet.visible = false;
}

space.show = function() {
	// hide all the assets we have
	for (i=0;i<config.space.planets.count;i++) {
		config.space.planets.list[i].obj.visible = true;
	}
	space.targetplanet.visible = true;
	space.startplanet.visible = true;
}

space.render = function() {
	
//	for (i=0;i<config.space.planets.density;i++) {
//		config.space.planets.list[i].obj.position.x -= config.space.ship.speed;
//	}

	
}